structure NDExamples = struct
  open NaturalDeduction 
  
  infix 9 ^
  infix 8 v
  infixr 7 >

  infix 5 -- ==========
  infix 5 --- =========
  infix 5 ---- ========
  infix 5 ----- =======
  infix 5 ------ ======
  infix 5 ------- =====
  infix 5 -------- ====
  infix 5 --------- ===
  infix 5 ---------- ==

  infix 4 tru
  
  val imp_refl : proof =
    [
      []
      ----- Hyp "u"
      tru A
    ]
    ----- ImpI "u"
    tru A > A
  
  val and_comm : proof = 
    [ 
    [
      [ []
      ----- Hyp "u"
      tru A ^ B]
      ----- AndE2
      tru B
    ,
      [ []
      ----- Hyp "u"
      tru A ^ B]
      ----- AndE1
      tru A
    ]
    ----- AndI
    tru B ^ A]
    ----- ImpI "u"
    tru A ^ B > B ^ A
  val and_comm_nested : proof = 
    [ 
      [
        [ 
          []
          ---------- Hyp "u"
          tru A ^ B
        ]
        ---------- AndE2
        tru B
      ,
        [ 
          []
          ---------- Hyp "u"
          tru A ^ B
        ]
        ---------- AndE1
        tru A
      ]
      ---------- AndI
      tru B ^ A
    ]
    ---------- ImpI "u"
    tru A ^ B > B ^ A
  val and_comm_again : proof = 
    let
      val prove_b =
          [
            []
            ---------- Hyp "u"
            tru A ^ B
          ]
          ---------- AndE2
          tru B

      val prove_a =
          [
            []
            ---------- Hyp "u"
            tru A ^ B
          ]
          ---------- AndE1
          tru A
      in
          [
            [prove_b, prove_a]
            ---------- AndI
            tru B ^ A
          ]
          ---------- ImpI "u"
          tru A ^ B > B ^ A
    end
end